/** ݒ_CAO
 */
/*
 * Copyright (c) 2000-2005 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
//---------------------------------------------------------------------------
#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "PlayerUnit.h"
#include "OptionUnit.h"
#include "ifmmedia.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

//---------------------------------------------------------------------------
#ifdef SetDlgH
__fastcall TDialogForm::TDialogForm(HWND ParentWindow)
    : TSetDlgForm(ParentWindow)
#else
__fastcall TDialogForm::TDialogForm(TComponent* Owner)
    : TForm(Owner)
#endif
{
    // Jɑ̃^uANeBuɂĂ邩Ȃ
    OptionPageControl->ActivePage = PlayerTabSheet ;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::FormInit(void)
{
/** _CAȌs
 */
    AnsiString userDefExt ;
    g_var.get( &m_var, userDefExt ) ;
    m_playerFormPosX = m_var.option[ OPTION_WindowPosX ] ;
    m_playerFormPosY = m_var.option[ OPTION_WindowPosY ] ;

    MemoryPlayCheckBox->Checked = m_var.option[ OPTION_MemoryPlay ] ;
    ReturnErrCheckBox->Checked  = m_var.option[ OPTION_ReturnErr ] ;
    StayOnTopCheckBox->Checked  = m_var.option[ OPTION_StayOnTop ] ;
    NoActiveCheckBox->Checked   = m_var.option[ OPTION_NoActive ] ;
    PlayerPosCheckBox->Checked  = m_var.option[ OPTION_WindowPos ] ;

    PreviewCheckBox->Checked    = m_var.option[ OPTION_PreviewMovie ] ;
    PreviewPos1Edit->Text       = m_var.option[ OPTION_PreviewPos1 ] ;
    PreviewPos2Edit->Text       = m_var.option[ OPTION_PreviewPos2 ] ;
    MinimizedCheckBox->Checked  = m_var.option[ OPTION_Minimized ] ;
    MovieSizeRadioGroup->ItemIndex = m_var.option[ OPTION_MovieSize ] ;
    CenterCheckBox->Checked     = m_var.option[ OPTION_MovieCenter ] ;

    SusieOnlyCheckBox->Checked  = m_var.option[ OPTION_SusieOnly ] ;
    PlayByViXCheckBox->Checked  = m_var.option[ OPTION_PlayByViX ] ;
    PlayByViXCheckBox->Enabled  = m_var.option[ OPTION_IsViX ] ; //ĂяoViXłȂ΃O[AEg
    DebugCheckBox->Checked      = m_var.option[ OPTION_DebugMode ] ;

    for (int i=0; i < FILETYPE_COUNT; i++)
    {
        SupportCheckListBox->Checked[i] = m_var.playable[i] ;
    }

    TStringList* sl = new TStringList() ;
    ::getSusieCompatiAppName( sl ) ;
    AppListBox->Items->AddStrings( sl ) ;
    delete sl ;

    UserDefExtEdit->Text = userDefExt ;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::CancelButtonClick(TObject *Sender)
{
/** ݒύXȂ
 */
    Close() ;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::OKButtonClick(TObject *Sender)
{
/** ݒύXĕۑ
 */
    m_var.option[ OPTION_MemoryPlay ] = MemoryPlayCheckBox->Checked ;
    m_var.option[ OPTION_ReturnErr ]  = ReturnErrCheckBox->Checked ;
    m_var.option[ OPTION_StayOnTop ]  = StayOnTopCheckBox->Checked ;
    m_var.option[ OPTION_NoActive ]   = NoActiveCheckBox->Checked ;
    m_var.option[ OPTION_WindowPos ]  = PlayerPosCheckBox->Checked ;
    m_var.option[ OPTION_WindowPosX ] = m_playerFormPosX ;
    m_var.option[ OPTION_WindowPosY ] = m_playerFormPosY ;

    if ( (m_movieFormHeight != 0) && (m_movieFormWidth != 0) )
    {
        m_var.option[ OPTION_MoviePosX ]   = m_moviewFormPosX ;
        m_var.option[ OPTION_MoviePosY ]   = m_moviewFormPosY ;
        m_var.option[ OPTION_MovieHeight ] = m_movieFormHeight ;
        m_var.option[ OPTION_MovieWidth ]  = m_movieFormWidth ;
    }

    m_var.option[ OPTION_PreviewMovie ] = PreviewCheckBox->Checked ;
    m_var.option[ OPTION_PreviewPos1 ]  = PreviewPos1Edit->Text.ToIntDef(0) ;
    m_var.option[ OPTION_PreviewPos2 ]  = PreviewPos2Edit->Text.ToIntDef(5) ;
    m_var.option[ OPTION_Minimized ]    = MinimizedCheckBox->Checked ;
    m_var.option[ OPTION_MovieSize ]    = MovieSizeRadioGroup->ItemIndex ;
    m_var.option[ OPTION_MovieCenter ]  = CenterCheckBox->Checked ;

    m_var.option[ OPTION_SusieOnly ] = SusieOnlyCheckBox->Checked ;
    m_var.option[ OPTION_PlayByViX ] = PlayByViXCheckBox->Checked ;
    m_var.option[ OPTION_DebugMode ] = DebugCheckBox->Checked ;

    for (int i=0; i < FILETYPE_COUNT; i++)
    {
        m_var.playable[i] = SupportCheckListBox->Checked[i] ;
    }

    g_var.set( &m_var, UserDefExtEdit->Text ) ;


    /* WXgɕۑ */
    TRegistry *reg = new TRegistry ;
    //reg->RootKey = HKEY_CURRENT_USER ;
    bool opened = reg->OpenKey( "\\Software\\shimitei\\ifmm", true ) ;
    if ( ! opened )
    {
        ::ShowMessage( "WXgG[!\nݒۑł܂B" ) ;
        delete reg ;
        return ;
    }

    reg->WriteBool( "Memory",    m_var.option[ OPTION_MemoryPlay ] ) ;
    reg->WriteBool( "Error",     m_var.option[ OPTION_ReturnErr ] ) ;
    reg->WriteBool( "StayOnTop", m_var.option[ OPTION_StayOnTop ] ) ;
    reg->WriteBool( "NoActive",  m_var.option[ OPTION_NoActive ] ) ;
    reg->WriteBool( "WindowPos", m_var.option[ OPTION_WindowPos ] ) ;
    reg->WriteInteger( "WindowPosX", m_var.option[ OPTION_WindowPosX ] ) ;
    reg->WriteInteger( "WindowPosY", m_var.option[ OPTION_WindowPosY ] ) ;

    if ( (m_movieFormHeight != 0) && (m_movieFormWidth != 0) )
    {
        reg->WriteInteger( "MoviePosX",   m_var.option[ OPTION_MoviePosX ] ) ;
        reg->WriteInteger( "MoviePosY",   m_var.option[ OPTION_MoviePosY ] ) ;
        reg->WriteInteger( "MovieHeight", m_var.option[ OPTION_MovieHeight ] ) ;
        reg->WriteInteger( "MovieWidth",  m_var.option[ OPTION_MovieWidth ] ) ;
    }

    reg->WriteBool( "PreviewMovieFrame", m_var.option[ OPTION_PreviewMovie ] ) ;
    reg->WriteInteger( "PreviewPos1", m_var.option[ OPTION_PreviewPos1 ] ) ;
    reg->WriteInteger( "PreviewPos2", m_var.option[ OPTION_PreviewPos2 ] ) ;
    reg->WriteBool( "Minimized", m_var.option[ OPTION_Minimized ] ) ;
    reg->WriteInteger( "MovieSize", m_var.option[ OPTION_MovieSize ] ) ;
    reg->WriteBool( "MovieCenter", m_var.option[ OPTION_MovieCenter ] ) ;

    reg->WriteBool( "SusieOnly", m_var.option[ OPTION_SusieOnly ] ) ;
    reg->WriteBool( "PlayByViX", m_var.option[ OPTION_PlayByViX ] ) ;
    reg->WriteBool( "Debug", m_var.option[ OPTION_DebugMode ] ) ;

    reg->WriteBool( "WAVE", m_var.playable[ WAVEPLAY ] ) ;
    reg->WriteBool( "MIDI", m_var.playable[ MIDIPLAY ] ) ;
    reg->WriteBool( "AVI",  m_var.playable[ AVIPLAY ] ) ;
    reg->WriteBool( "AIFF", m_var.playable[ AIFFPLAY ] ) ;
    reg->WriteBool( "MOV",  m_var.playable[ MOVPLAY ] ) ;
    reg->WriteBool( "MPEG", m_var.playable[ MPEGPLAY ] ) ;
    reg->WriteBool( "MPA",  m_var.playable[ MPAPLAY ] ) ;
    reg->WriteBool( "AU",   m_var.playable[ AUPLAY ] ) ;
    reg->WriteBool( "OGG",  m_var.playable[ OGGPLAY ] ) ;
    reg->WriteBool( "RM",   m_var.playable[ RMPLAY ] ) ;
    reg->WriteBool( "USER", m_var.playable[ USERPLAY ] ) ;

    reg->WriteString( "UserDefExt", UserDefExtEdit->Text ) ;

    reg->CloseKey() ;
    delete reg ;

    Close() ;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::PlayerPosButtonClick(TObject *Sender)
{
/** v[[̃EBhEʒu̐ݒ
 * v[[EBhEJāAƂ̈ʒuݒ肷
 */
    TPlayForm* form = new TPlayForm(this) ;

    form->Left = 0 ;
    form->Top  = 0 ;

    form->ShowModal() ;

    m_playerFormPosX = form->Left ;
    m_playerFormPosY = form->Top ;

    delete form ;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::CustomButtonClick(TObject *Sender)
{
/** v[[̃EBhEʒuƃTCY̐ݒ
 * v[[EBhEJāAƂ̈ʒuƃTCYݒ肷
 */
    TPlayForm* form = new TPlayForm(this) ;

    form->PopupMenu = NULL ;
    form->ScrollBox->OnClick = NULL ;
    form->OnResize = form->FormResizeEx ;
    form->BorderStyle = bsSizeable ;

#define DEFAULT_WIDTH 260
    form->ClientHeight += Screen->WorkAreaHeight * 2 / 3 +2 ;
    form->ClientWidth  += Screen->WorkAreaWidth  * 2 / 3 +2 - DEFAULT_WIDTH ;
    form->Top    = (Screen->WorkAreaHeight - form->Height) /2 ;
    form->Left   = (Screen->WorkAreaWidth - form->Width) /2 ;

    form->ShowModal() ;

    m_moviewFormPosX = form->Left ;
    m_moviewFormPosY = form->Top ;
    m_movieFormHeight = form->MoviePanel->Height -2 ;
    m_movieFormWidth  = form->MoviePanel->Width  -2 ;

    delete form ;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::SupportLabelDblClick(TObject *Sender)
{
// BIvVôP
    this->Tag++ ;
    if ( this->Tag > 5 )
    {
        DebugCheckBox->Visible = true ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::SupportLabelMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
// BIvVôQ
    if ( Shift.Contains( ssShift ) && Shift.Contains( ssRight ) )
    {
        DebugCheckBox->Enabled = true ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::AppAddButtonClick(TObject *Sender)
{
/** Susie݊AvWXgɓo^
 */
    TRegistry *reg = new TRegistry ;
    //reg->RootKey = HKEY_CURRENT_USER ;
    bool opened = reg->OpenKey( "\\Software\\shimitei\\ifmm\\SusieCompati", true ) ;

    if ( opened )
    {
        AnsiString dataname = AppEdit->Text ;
        if ( ! dataname.IsEmpty() )
        {
            reg->WriteInteger( dataname, 0 ) ;
            AppListBox->Items->Add( dataname ) ;
            AppEdit->Text = "" ;
        }
    }
    else
    {
        ::ShowMessage( "WXgI[vG[I" ) ;
    }

    delete reg ;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::AppDelButtonClick(TObject *Sender)
{
/** Susie݊o^AvWXg폜
 */
    int index = AppListBox->ItemIndex ;
    if ( index == -1 ) return ;

    TRegistry *reg = new TRegistry ;
    //reg->RootKey = HKEY_CURRENT_USER ;
    bool opened = reg->OpenKey( "\\Software\\shimitei\\ifmm\\SusieCompati", false ) ;
    if ( opened )
    {
        if ( reg->DeleteValue( AppListBox->Items->Strings[index] ) )
        {
            AppListBox->Items->Delete( index ) ;
        }
        else
        {
            ::ShowMessage( "폜Ɏs܂B" ) ;
        }
    }
    else
    {
        ::ShowMessage( "WXgI[vG[I" ) ;
    }
    delete reg ;
}
//---------------------------------------------------------------------------


